let dappaccount = {};

let { PrivateKey } = require("eosjs-ecc");
let helperaction = require("./common/helper");
const axios = require("axios").default;
let chaininfo = require("./common/chaininfo.json");

dappaccount.register_both = async (env, email, contact, otp) => {
  try {
    if (!chaininfo[env]) {
      throw new Error("Must provide environment correctly : kylin / main");
    }
    let prv_key = await PrivateKey.randomKey();
    prv_key = prv_key.toWif();
    const response_reg = await helperaction.reguser(
      env,
      email,
      contact,
      otp,
      prv_key
    );
    return {accname: response_reg.accname, key: prv_key};
  } catch (err) {
    throw new Error(err);
  }
};

dappaccount.verifycontact = async (env,contact) => {
  try {
    if (!chaininfo[env]) {
      throw new Error("Must provide environment correctly : kylin / main");
    }
    let resp = await axios.post(chaininfo[env].twofactregcon, {
      contact: contact,
    });
    return resp.data;
  } catch (err) {
    throw new Error(err.response.data.message);
  }
};

dappaccount.verifyemailreg = async (env, email) => {
  try {
    if (!chaininfo[env]) {
      throw new Error("Must provide environment correctly : kylin / main");
    }
    let resp = await axios.post(chaininfo[env].twofactregemail, {
      email: email,
    });
    return resp.data;
  } catch (err) {
    throw new Error(err.response.data.message);
  }
};

dappaccount.verifyemailreset = async (env, email) => {
  try {
    if (!chaininfo[env]) {
      throw new Error("Must provide environment correctly : kylin / main");
    }
    let dappacc = await helperaction.converttovacc(email.toLowerCase());
    let resp = await axios.post(chaininfo[env].twofactlogin, {
      vaccount: dappacc,
      email: email,
    });
    return resp.data;
  } catch (err) {
    throw new Error(err.response.data.message);
  }
};

dappaccount.recover = async (env, email, auth_code) => {
  try {
    if (!chaininfo[env]) {
      throw new Error('Must provide environment correctly : kylin / main');
    }
    let prv_key = await PrivateKey.randomKey();
    prv_key = prv_key.toWif();
    const response_reg = await helperaction.recoveruser(
      env,
      email,
      auth_code,
      prv_key
    );
    return {accname: response_reg.accname, key: prv_key};
  } catch (err) {
    throw new Error(err);
  }
};

module.exports = dappaccount;
